﻿using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace CKMail
{
    public class CMidi
    {
        /// <summary> コンストラクター
        /// </summary>
        /// <param name="vfilename"></param>
        public CMidi(string vfilename)
        {
            _filename = vfilename;
        }

        const string ALIAS_NAME = "MediaFile";
        private string _filename = String.Empty;    // コンストラクターから取得

        [DllImport("winmm.dll", CharSet = CharSet.Auto)]
        private static extern int mciSendString(string command,
                System.Text.StringBuilder buffer, int bufferSize, IntPtr hwndCallback);

        /// <summary> CanStartMidi
        /// </summary>
        /// <returns></returns>
        public bool CanStartMidi()
        {
            //ファイルを開く
            string cmd = "open \"" + _filename + "\" alias " + ALIAS_NAME;
            try
            {
                if (mciSendString(cmd, null, 0, IntPtr.Zero) != 0)
                    return false;
                //再生する
                cmd = "play " + ALIAS_NAME;
                mciSendString(cmd, null, 0, IntPtr.Zero);
                return true;
            }
            catch
            {
                return false;
            }            
        }

        /// <summary> [StopMidi]メソッド
        /// </summary>
        public void StopMidi()
        {
            //再生しているWAVEを停止する
            string cmd = "stop " + ALIAS_NAME;
            try
            {
                mciSendString(cmd, null, 0, IntPtr.Zero);
                //閉じる
                cmd = "close " + ALIAS_NAME;
                mciSendString(cmd, null, 0, IntPtr.Zero);
            }
            catch (Exception ex)
            {
                CC.ShowMsg(ex.Message, CC.MSG_EXC);
            }
        }

    }
}
